#include <bits/stdc++.h>
using namespace std;

int main() {
    int n, q, k;
    cin >> n >> q >> k;

    vector<int> favorite_permutation(n);
    for (int i = 0; i < n; i++) {
        cin >> favorite_permutation[i];
    }

    vector<int> current_order(n);
    for (int i = 0; i < n; i++) {
        current_order[i] = i + 1;
    }

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;

        vector<int> interval(r - l + 1);
        for (int j = l; j <= r; j++) {
            interval[j - l] = current_order[j - 1];
        }

        sort(interval.begin(), interval.end(), [&favorite_permutation](int a, int b) {
            return favorite_permutation[a - 1] < favorite_permutation[b - 1];
        });

        for (int j = l; j <= r; j++) {
            current_order[j - 1] = interval[j - l];
        }
    }

    int result = current_order[k - 1];
    cout << result << endl;

    return 0;
}
